diff --git a/drupal7/sites/all/modules/file_entity/file_entity.pages.inc b/drupal7/sites/all/modules/file_entity/file_entity.pages.inc
index 31d0d763..a00245a9 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.pages.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.pages.inc
@@ -37,20 +37,34 @@ function file_entity_download_page($file) {
   }
 
   $headers = array(
-    'Content-Type' => 'force-download',
-    'Content-Disposition' => 'attachment; filename="' . $file->filename . '"',
+    'Content-Type' => mime_header_encode($file->filemime),
+    'Content-Disposition' => 'attachment; filename="' . mime_header_encode(drupal_basename($file->uri)) . '"',
     'Content-Length' => $file->filesize,
     'Content-Transfer-Encoding' => 'binary',
     'Pragma' => 'no-cache',
     'Cache-Control' => 'must-revalidate, post-check=0, pre-check=0',
     'Expires' => '0',
-    'Accept-Ranges' => 'bytes',
   );
 
   // Let other modules alter the download headers.
   drupal_alter('file_download_headers', $headers, $file);
 
-  file_transfer($file->uri, $headers);
+  // Let other modules know the file is being downloaded.
+  module_invoke_all('file_transfer', $file->uri, $headers);
+
+  if (file_entity_file_is_local($file)) {
+    // For local files, transfer the file and do not reveal the actual URL.
+    file_transfer($file->uri, $headers);
+  }
+  else {
+    // For remote files, just redirect the user to that file's actual URL.
+    $headers['Location'] = file_create_url($file->uri);
+    foreach ($headers as $name => $value) {
+      drupal_add_http_header($name, $value);
+    }
+    drupal_send_headers();
+    drupal_exit();
+  }
 }
 
 /**
@@ -66,6 +80,7 @@ function file_entity_download_page($file) {
 function file_entity_add_upload($form, &$form_state, array $options = array()) {
   $step = (isset($form_state['step']) && in_array($form_state['step'], array(1, 2, 3, 4))) ? $form_state['step'] : 1;
   $form['#step'] = $step;
+  $form['#options'] = $options;
   switch ($step) {
     case 1:
       return file_entity_add_upload_step_upload($form, $form_state, $options);
@@ -143,16 +158,32 @@ function file_entity_add_upload_step_filetype($form, &$form_state, array $option
 function file_entity_add_upload_step_scheme($form, &$form_state, array $options = array()) {
   $file = file_load($form_state['storage']['upload']);
 
-  $options = array();
+  $schemes = array();
   foreach (file_get_stream_wrappers(STREAM_WRAPPERS_WRITE_VISIBLE) as $scheme => $info) {
-    $options[$scheme] = check_plain($info['description']);
+    $schemes[$scheme] = check_plain($info['description']);
+  }
+
+  // Remove any schemes not found in the instance settings.
+  if (!empty($options['schemes'])) {
+    $schemes = array_intersect_key($schemes, $options['schemes']);
+  }
+
+  // Determine which scheme to use as the default value.
+  if (isset($form_state['storage']['scheme'])) {
+    $fallback_scheme = $form_state['storage']['scheme'];
+  }
+  elseif (!empty($options['uri_scheme'])) {
+    $fallback_scheme = $options['uri_scheme'];
+  }
+  else {
+    $fallback_scheme = file_default_scheme();
   }
 
   $form['scheme'] = array(
     '#type' => 'radios',
     '#title' => t('Destination'),
-    '#options' => $options,
-    '#default_value' => isset($form_state['storage']['scheme']) ? $form_state['storage']['scheme'] : file_default_scheme(),
+    '#options' => $schemes,
+    '#default_value' => $fallback_scheme,
     '#required' => TRUE,
   );
 
@@ -179,6 +210,16 @@ function file_entity_add_upload_step_fields($form, &$form_state, array $options
   $file = file_load($form_state['storage']['upload']);
   $file->type = $form_state['storage']['type'];
 
+  // Let users modify the filename here.
+  $form['filename'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Name'),
+    '#default_value' => $file->filename,
+    '#required' => TRUE,
+    '#maxlength' => 255,
+    '#weight' => -10,
+  );
+
   // Add fields.
   field_attach_form('file', $file, $form, $form_state);
 
@@ -207,7 +248,7 @@ function file_entity_usage_page($file) {
   foreach (file_usage_list($file) as $module => $usage) {
     $info = system_get_info('module', $module);
 
-    // There are cases, where actual entitiy doesen't exist.
+    // There are cases where the actual entity doesn't exist.
     // We have to handle this.
     foreach ($usage as $entity_type => $entity_ids) {
       $entity_info = entity_get_info($entity_type);
@@ -315,7 +356,7 @@ function file_entity_add_upload_submit($form, &$form_state) {
           $form['#step'] += ($trigger == 'edit-previous') ? -1 : 1;
           $form_state['storage']['type'] = reset($candidates_keys);
         }
-        elseif (variable_get('file_entity_file_upload_wizard_skip_file_type', FALSE)) {
+        elseif (!$candidates || variable_get('file_entity_file_upload_wizard_skip_file_type', FALSE)) {
           // Do not assign the file a file type.
           $form['#step'] += ($trigger == 'edit-previous') ? -1 : 1;
           $form_state['storage']['type'] = FILE_TYPE_NONE;
@@ -323,17 +364,36 @@ function file_entity_add_upload_submit($form, &$form_state) {
       }
       else {
         // Check if we can skip step 3.
+        $options = $form['#options'];
         $schemes = file_get_stream_wrappers(STREAM_WRAPPERS_WRITE_VISIBLE);
-        if (count($schemes) == 1) {
+
+        // Remove any schemes not found in the instance settings.
+        if (!empty($options['schemes'])) {
+          $schemes = array_intersect_key($schemes, $options['schemes']);
+        }
+
+        if (!file_entity_file_is_writeable($file)) {
+          // The file is read-only (remote) and must use its provided scheme.
+          $form['#step'] += ($trigger == 'edit-previous') ? -1 : 1;
+          $form_state['storage']['scheme'] = file_uri_scheme($file->uri);
+        }
+        elseif (count($schemes) == 1) {
           // There is only one possible stream wrapper for this file.
           // Skip the third page.
           $form['#step'] += ($trigger == 'edit-previous') ? -1 : 1;
           $form_state['storage']['scheme'] = key($schemes);
         }
         elseif (variable_get('file_entity_file_upload_wizard_skip_scheme', FALSE)) {
-          // Assign the file the default scheme.
           $form['#step'] += ($trigger == 'edit-previous') ? -1 : 1;
-          $form_state['storage']['scheme'] = file_default_scheme();
+
+          // Fallback to the URI scheme specified in the field settings
+          // otherwise use the default file scheme.
+          if (!empty($options['uri_scheme'])) {
+            $form_state['storage']['scheme'] = $options['uri_scheme'];
+          }
+          else {
+            $form_state['storage']['scheme'] = file_default_scheme();
+          }
         }
       }
     }
@@ -480,6 +540,9 @@ function file_entity_add_upload_multiple_submit($form, &$form_state) {
     $form['upload']['#upload_location'] . '/' :
     variable_get('file_default_scheme', 'public') . '://';
 
+  // Ensure writable destination directory for the files.
+  file_prepare_directory($upload_location, FILE_CREATE_DIRECTORY | FILE_MODIFY_PERMISSIONS);
+
   // We can't use file_save_upload() because of
   // http://www.jacobsingh.name/content/tight-coupling-no-not.
   foreach ($form_state['values']['upload'] as $uploaded_file) {
@@ -568,8 +631,23 @@ function file_entity_edit($form, &$form_state, $file) {
   if (file_entity_file_is_writeable($file)) {
     // Set up replacement file validation.
     $replacement_options = array();
-    // The replacement file must have the same extension as the original file.
-    $replacement_options['file_extensions'] = pathinfo($file->uri, PATHINFO_EXTENSION);
+
+    // The replacement file must have an extension valid for the original type.
+    $file_extensions = array();
+    $file_type_name = isset($file->type) ? $file->type : file_get_type($file);
+    if ($file_type_name && ($file_type = file_type_load($file_type_name))) {
+      $file_extensions = file_type_get_valid_extensions($file_type);
+    }
+
+    // Set allowed file extensions.
+    if (!empty($file_extensions)) {
+      // Set to type based file extensions.
+      $replacement_options['file_extensions'] = implode(' ', $file_extensions);
+    }
+    else {
+      // Fallback to the extension of the current file.
+      $replacement_options['file_extensions'] = pathinfo($file->uri, PATHINFO_EXTENSION);
+    }
 
     $form['replace_upload'] = array(
       '#type' => 'file',
@@ -656,6 +734,7 @@ function file_entity_edit($form, &$form_state, $file) {
     '#value' => t('Save'),
     '#weight' => 5,
     '#submit' => array('file_entity_edit_submit'),
+    '#validate' => array('file_entity_edit_validate'),
   );
   $form['actions']['delete'] = array(
     '#type' => 'submit',
@@ -722,12 +801,29 @@ function file_entity_edit_validate($form, &$form_state) {
  */
 function file_entity_edit_submit($form, &$form_state) {
   $file = $form_state['file'];
+  $orphaned_uri = '';
 
   // Check if a replacement file has been uploaded.
   if (!empty($form_state['values']['replace_upload'])) {
     $replacement = $form_state['values']['replace_upload'];
     // Move file from temp to permanent home.
-    file_unmanaged_copy($replacement->uri, $file->uri, FILE_EXISTS_REPLACE);
+    $destination_uri = file_uri_scheme($file->uri) . '://' . file_uri_target($replacement->uri);
+    $replace_mode = $destination_uri == $file->uri ? FILE_EXISTS_REPLACE : FILE_EXISTS_RENAME;
+    if ($new_file_uri = file_unmanaged_copy($replacement->uri, $destination_uri, $replace_mode)) {
+      // @todo Add watchdog() about replaced file here?
+
+      // Remove temporary file.
+      file_delete($replacement);
+
+      // Update if the uri target has changed.
+      if ($new_file_uri != $file->uri) {
+       // Store the original file uri to delete if save is sucessful.
+       $orphaned_uri = $file->uri;
+
+        // Update file entity uri.
+        $file->uri = $new_file_uri;
+      }
+    }
   }
 
   // Run entity form submit handling and save the file.
@@ -767,6 +863,15 @@ function file_entity_edit_submit($form, &$form_state) {
   watchdog('file', '@type: updated %title.', $args);
   drupal_set_message(t('@type %title has been updated.', $args));
 
+  // Clean up orphaned file.
+  if (!empty($orphaned_uri)) {
+    file_unmanaged_delete($orphaned_uri);
+
+    $args['@orphaned'] = file_uri_target($orphaned_uri);
+    watchdog('file', '@type: deleted orphaned file @orphaned for %title.', $args);
+    drupal_set_message(t('The replaced @type @orphaned has been deleted.', $args));
+  }
+
   $form_state['redirect'] = 'file/' . $file->fid;
 
   // Clear the page and block caches.
@@ -984,3 +1089,84 @@ function file_entity_get_upload_validators(array $options = array()) {
 
   return $validators;
 }
+
+function file_entity_upload_archive_form($form, &$form_state) {
+  $options = array(
+    'file_extensions' => archiver_get_extensions(),
+  );
+
+  $form['upload'] = array(
+    '#type' => 'managed_file',
+    '#title' => t('Upload an archive file'),
+    '#upload_location' => NULL, // Upload to the temporary directory.
+    '#upload_validators' => file_entity_get_upload_validators($options),
+    '#progress_indicator' => 'bar',
+    '#required' => TRUE,
+    '#pre_render' => array('file_managed_file_pre_render', 'file_entity_upload_validators_pre_render'),
+  );
+
+  $form['pattern'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Pattern'),
+    '#description' => t('Only files matching this pattern will be imported. For example, to import all jpg and gif files, the pattern would be <em>*.jpg|*.gif</em>. Use <em>.*</em> to extract all files in the archive.'),
+    '#default_value' => '.*',
+    '#required' => TRUE,
+  );
+
+  $form['actions'] = array('#type' => 'actions');
+  $form['actions']['submit'] = array(
+    '#type' => 'submit',
+    '#value' => t('Submit'),
+  );
+
+  form_load_include($form_state, 'inc', 'file_entity', 'file_entity.pages');
+
+  return $form;
+}
+
+/**
+ * Upload a file.
+ */
+function file_entity_upload_archive_form_submit($form, &$form_state) {
+  $form_state['files'] = array();
+
+  if ($archive = file_load($form_state['values']['upload'])) {
+    if ($archiver = archiver_get_archiver($archive->uri)) {
+      $files = $archiver->listContents();
+
+      $extract_dir = file_default_scheme() . '://' . pathinfo($archive->filename, PATHINFO_FILENAME);
+      $extract_dir = file_destination($extract_dir, FILE_EXISTS_RENAME);
+      if (!file_prepare_directory($extract_dir, FILE_MODIFY_PERMISSIONS | FILE_CREATE_DIRECTORY)) {
+        throw new Exception(t('Unable to prepar, e directory %dir for extraction.', array('%dir' => $extract_dir)));
+      }
+
+      $archiver->extract($extract_dir);
+      $pattern = '/' . $form_state['values']['pattern'] . '/';
+      if ($files = file_scan_directory($extract_dir, $pattern)) {
+        foreach ($files as $file) {
+          $file->status = FILE_STATUS_PERMANENT;
+          $file->uid = $archive->uid;
+          file_save($file);
+          $form_state['files'][$file->fid] = $file;
+        }
+      }
+      drupal_set_message(t('Extracted %file and added @count new files.', array('%file' => $archive->filename, '@count' => count($files))));
+    }
+    else {
+      throw new Exception(t('Cannot extract %file, not a valid archive.', array('%file' => $archive->uri)));
+    }
+  }
+
+  // Redirect to the file edit page.
+  if (file_entity_access('edit') && module_exists('multiform')) {
+    $destination = array('destination' => 'admin/content/file');
+    if (isset($_GET['destination'])) {
+      $destination = drupal_get_destination();
+      unset($_GET['destination']);
+    }
+    $form_state['redirect'] = array('admin/content/file/edit-multiple/' . implode(' ', array_keys($form_state['files'])), array('query' => $destination));
+  }
+  else {
+    $form_state['redirect'] = 'admin/content/file';
+  }
+}
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.test b/drupal7/sites/all/modules/file_entity/file_entity.test
index acc10926..4cc4b9a7 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.test
+++ b/drupal7/sites/all/modules/file_entity/file_entity.test
@@ -17,10 +17,19 @@ class FileEntityTestHelper extends DrupalWebTestCase {
     parent::setUp($modules);
   }
 
-  protected function setUpFiles() {
+  protected function setUpFiles($defaults = array()) {
+    // Populate defaults array.
+    $defaults += array(
+      'uid' => 1,
+      'status' => FILE_STATUS_PERMANENT,
+    );
+
     $types = array('text', 'image');
     foreach ($types as $type) {
       foreach ($this->drupalGetTestFiles($type) as $file) {
+        foreach ($defaults as $key => $value) {
+          $file->$key = $value;
+        }
         $this->files[$type][] = file_save($file);
       }
     }
@@ -261,7 +270,7 @@ class FileEntityUnitTestCase extends FileEntityTestHelper {
 
   function setUp() {
     parent::setUp();
-    parent::setUpFiles();
+    $this->setUpFiles();
   }
 
   /**
@@ -665,7 +674,7 @@ class FileEntityReplaceTestCase extends FileEntityTestHelper {
 
   function setUp() {
     parent::setUp();
-    parent::setUpFiles();
+    $this->setUpFiles();
   }
 
   /**
@@ -705,7 +714,8 @@ class FileEntityReplaceTestCase extends FileEntityTestHelper {
     $this->assertEqual($file->filename, $original->filename, 'Updated file name did not change.');
     $this->assertNotEqual($file->filesize, $original->filesize, 'Updated file size changed from previous file.');
     $this->assertEqual($file->filesize, $replacement->filesize, 'Updated file size matches uploaded file.');
-    $this->assertEqual(file_get_contents($replacement->uri), file_get_contents($file->uri), 'Updated file contents matches uploaded file.');
+    $this->assertEqual(file_get_contents($file->uri), file_get_contents($replacement->uri), 'Updated file contents matches uploaded file.');
+    $this->assertFalse(entity_load('file', FALSE, array('status' => 0)), 'Temporary file used for replacement was deleted.');
 
     // Get an image file.
     $image = reset($this->files['image']);
@@ -746,7 +756,7 @@ class FileEntityTokenTestCase extends FileEntityTestHelper {
 
   function setUp() {
     parent::setUp();
-    parent::setUpFiles();
+    $this->setUpFiles();
   }
 
   function testFileEntityTokens() {
@@ -800,7 +810,7 @@ class FileEntityTypeTestCase extends FileEntityTestHelper {
 
   function setUp() {
     parent::setUp();
-    parent::setUpFiles();
+    $this->setUpFiles();
   }
 
   /**
@@ -1069,13 +1079,22 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
 
   function setUp() {
     parent::setUp();
-    parent::setUpFiles();
+    $this->setUpFiles(array('uid' => 0));
+
+    // Unset the fact that file_entity_install() adds the 'view files'
+    // permission to all user roles. This messes with being able to fully unit
+    // test the file_entity_access() function.
+    $roles = user_roles();
+    foreach ($roles as $rid => $role) {
+      user_role_revoke_permissions($rid, array('view files'));
+    }
   }
 
   /**
    * Asserts file_entity_access correctly grants or denies access.
    */
   function assertFileEntityAccess($ops, $file, $account) {
+    drupal_static_reset('file_entity_access');
     foreach ($ops as $op => $result) {
       $msg = t("file_entity_access returns @result with operation '@op'.", array('@result' => $result ? 'true' : 'false', '@op' => $op));
       $this->assertEqual($result, file_entity_access($op, $file, $account), $msg);
@@ -1107,32 +1126,24 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
     $web_user = $this->drupalCreateUser(array('create files', 'view own files'));
     $this->assertFileEntityAccess(array('view' => FALSE), $file, $web_user);
     $file->uid = $web_user->uid;
-    $file->status = FILE_STATUS_PERMANENT;
-    file_save($file);
     $this->assertFileEntityAccess(array('view' => TRUE), $file, $web_user);
 
     // User can download own files but no other files.
     $web_user = $this->drupalCreateUser(array('create files', 'download own image files'));
     $this->assertFileEntityAccess(array('download' => FALSE), $file, $web_user);
     $file->uid = $web_user->uid;
-    $file->status = FILE_STATUS_PERMANENT;
-    file_save($file);
     $this->assertFileEntityAccess(array('download' => TRUE), $file, $web_user);
 
     // User can update own files but no other files.
     $web_user = $this->drupalCreateUser(array('create files', 'view own files', 'edit own image files'));
     $this->assertFileEntityAccess(array('update' => FALSE), $file, $web_user);
     $file->uid = $web_user->uid;
-    $file->status = FILE_STATUS_PERMANENT;
-    file_save($file);
     $this->assertFileEntityAccess(array('update' => TRUE), $file, $web_user);
 
     // User can delete own files but no other files.
     $web_user = $this->drupalCreateUser(array('create files', 'view own files', 'edit own image files', 'delete own image files'));
     $this->assertFileEntityAccess(array('delete' => FALSE), $file, $web_user);
     $file->uid = $web_user->uid;
-    $file->status = FILE_STATUS_PERMANENT;
-    file_save($file);
     $this->assertFileEntityAccess(array('delete' => TRUE), $file, $web_user);
 
     // User can view any file.
@@ -1172,8 +1183,6 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
     $this->assertResponse(200, 'Users with access can access the file add page');
 
     $file = reset($this->files['text']);
-    $file->status = FILE_STATUS_PERMANENT;
-    file_save($file);
 
     // This fails.. No clue why but, tested manually and works as should.
     //$web_user = $this->drupalCreateUser(array('view own files'));
@@ -1188,16 +1197,19 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
     $url = "file/{$file->fid}/download";
     $web_user = $this->drupalCreateUser(array());
     $this->drupalLogin($web_user);
-    $this->drupalGet($url, array('query' => array('token' => $this->drupalGetToken($url))));
+    $this->drupalGet($url, array('query' => array('token' => file_entity_get_download_token($file))));
     $this->assertResponse(403, 'Users without access can not download the file');
     $web_user = $this->drupalCreateUser(array('download any document files'));
     $this->drupalLogin($web_user);
-    $this->drupalGet($url, array('query' => array('token' => $this->drupalGetToken($url))));
+    $this->drupalGet($url, array('query' => array('token' => file_entity_get_download_token($file))));
     $this->assertResponse(200, 'Users with access can download the file');
     $this->drupalGet($url, array('query' => array('token' => 'invalid-token')));
     $this->assertResponse(403, 'Cannot download file with in invalid token.');
     $this->drupalGet($url);
     $this->assertResponse(403, 'Cannot download file without a token.');
+    variable_set('file_entity_allow_insecure_download', TRUE);
+    $this->drupalGet($url);
+    $this->assertResponse(200, 'Users with access can download the file without a token when file_entity_allow_insecure_download is set.');
 
     $web_user = $this->drupalCreateUser(array());
     $this->drupalLogin($web_user);
@@ -1233,7 +1245,6 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
       // Create private, permanent files owned by this user only he's an owner.
       if (!empty($case['owner'])) {
         $file = next($this->files['text']);
-        $file->status = FILE_STATUS_PERMANENT;
         $file->uid = $account->uid;
         file_save($file);
         $file = file_move($file, 'private://');
@@ -1256,3 +1267,47 @@ class FileEntityAccessTestCase extends FileEntityTestHelper {
     }
   }
 }
+
+class FileEntityAttributeOverrideTestCase extends FileEntityTestHelper {
+
+  public static function getInfo() {
+    return array(
+      'name' => 'File entity attribute override',
+      'description' => 'Test overriding file entity attributes.',
+      'group' => 'File entity',
+    );
+  }
+
+  function setUp() {
+    parent::setUp();
+    $this->setUpFiles();
+  }
+
+  /**
+   * Test to see if file attributes can be overridden.
+   */
+  function testFileEntityFileAttributeOverrides() {
+    $overrides = array(
+      'width' => 40,
+      'height' => 20,
+      'alt' => $this->randomName(),
+      'title' => $this->randomName(),
+
+    );
+
+    // Retrieve an image file entity for testing.
+    $file = reset($this->files['image']);
+
+    // Override a variety of attributes.
+    foreach ($overrides as $override => $value) {
+      $file->override['attributes'][$override] = $value;
+    }
+
+    // Test that the attributes have been overridden.
+    $build = file_view_file($file, 'full');
+
+    foreach ($overrides as $attribute => $expected_value) {
+      $this->assertEqual($build['#item'][$attribute], $expected_value, format_string('The %attribute was overridden correctly.', array('%attribute' => $attribute)));
+    }
+  }
+}
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.theme.inc b/drupal7/sites/all/modules/file_entity/file_entity.theme.inc
index 123b83ed..1819d979 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.theme.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.theme.inc
@@ -58,9 +58,9 @@ function theme_file_entity_download_link($variables) {
     $variables['text'] = t('Download [file:name]');
   }
 
-  // Peform unsanitized token replacement if $uri['options']['html'] is empty
+  // Perform unsanitized token replacement if $uri['options']['html'] is empty
   // since then l() will escape the link text.
-  $variables['text'] = token_replace($variables['text'], array('file' => $file), array('clear' => TRUE, 'sanitize' => empty($uri['options']['html'])));
+  $variables['text'] = token_replace($variables['text'], array('file' => $file), array('clear' => TRUE, 'sanitize' => !empty($uri['options']['html'])));
 
   $output = '<span class="file">' . $icon . ' ' . l($variables['text'], $uri['path'], $uri['options']);
   $output .= ' ' . '<span class="file-size">(' . format_size($file->filesize) . ')</span>';
@@ -142,8 +142,10 @@ function theme_file_entity_file_video($variables) {
   if ($variables['muted']) {
     $video_attributes['muted'] = 'muted';
   }
-  if ($variables['width'] && $variables['height']) {
+  if ($variables['width']) {
     $video_attributes['width'] = $variables['width'];
+  }
+  if ($variables['height']) {
     $video_attributes['height'] = $variables['height'];
   }
 
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.views.inc b/drupal7/sites/all/modules/file_entity/file_entity.views.inc
index ea8b5a1e..6a37901d 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.views.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.views.inc
@@ -27,6 +27,16 @@ function file_entity_views_data() {
       'handler' => 'views_handler_argument_file_type',
     ),
   );
+
+  // File schema type.
+  $data['file_managed']['schema_type'] = array(
+    'title' => t('Schema type'),
+    'help' => t('Filter files by schema, such as public or private.'),
+    'filter' => array(
+      'handler' => 'views_handler_filter_schema_type',
+    ),
+  );
+
   // Rendered file.
   $data['file_managed']['rendered'] = array(
     'title' => t('Rendered'),
@@ -99,11 +109,15 @@ function file_entity_views_data() {
     'help' => t('Provide a simple link to view the usage of the file entity.'),
     'field' => array(
       'handler' => 'views_handler_field_file_link_usage',
+      'click sortable' => TRUE,
       'real field' => 'fid',
       'additional fields' => array(
         'fid',
       ),
     ),
+    'sort' => array(
+      'handler' => 'views_handler_sort',
+    ),
   );
 
   return $data;
diff --git a/drupal7/sites/all/modules/file_entity/tests/file_entity_test.info b/drupal7/sites/all/modules/file_entity/tests/file_entity_test.info
index 39040fbf..cf354022 100644
--- a/drupal7/sites/all/modules/file_entity/tests/file_entity_test.info
+++ b/drupal7/sites/all/modules/file_entity/tests/file_entity_test.info
@@ -5,9 +5,9 @@ core = 7.x
 dependencies[] = file_entity
 hidden = TRUE
 
-; Information added by drupal.org packaging script on 2013-10-25
-version = "7.x-2.0-alpha3"
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "file_entity"
-datestamp = "1382744726"
+datestamp = "1412420930"
 
diff --git a/drupal7/sites/all/modules/file_entity/views/views_handler_field_file_link_download.inc b/drupal7/sites/all/modules/file_entity/views/views_handler_field_file_link_download.inc
index 088d18cc..21c27295 100644
--- a/drupal7/sites/all/modules/file_entity/views/views_handler_field_file_link_download.inc
+++ b/drupal7/sites/all/modules/file_entity/views/views_handler_field_file_link_download.inc
@@ -24,7 +24,7 @@ class views_handler_field_file_link_download extends views_handler_field_file_li
     $this->options['alter']['make_link'] = TRUE;
     $uri = file_entity_download_uri($file);
     $this->options['alter']['path'] = $uri['path'];
-    $this->options['alter'] += $uri['options'];
+    $this->options['alter'] = drupal_array_merge_deep($this->options['alter'], $uri['options']);
 
     $text = !empty($this->options['text']) ? $this->options['text'] : t('Download');
     return $text;
diff --git a/drupal7/sites/all/modules/file_entity/views/views_handler_field_file_link_usage.inc b/drupal7/sites/all/modules/file_entity/views/views_handler_field_file_link_usage.inc
index f4f64c24..49e1df8d 100644
--- a/drupal7/sites/all/modules/file_entity/views/views_handler_field_file_link_usage.inc
+++ b/drupal7/sites/all/modules/file_entity/views/views_handler_field_file_link_usage.inc
@@ -25,7 +25,17 @@ class views_handler_field_file_link_usage extends views_handler_field_file_link
     $this->options['alter']['path'] = "file/$file->fid/usage";
     $this->options['alter']['query'] = drupal_get_destination();
 
-    $text = !empty($this->options['text']) ? $this->options['text'] : t('Usage');
+    // Get total count for each file.
+    $total_count = 0;
+    foreach (file_usage_list($file) as $module => $usage) {
+      foreach ($usage as $entity_type => $entity_ids) {
+        foreach ($entity_ids as $id => $count) {
+          $total_count += $count;
+        }
+      }
+    }
+
+    $text = !empty($this->options['text']) ? $this->options['text'] : format_plural((int) $total_count, '1 place', '@count places');
     return $text;
   }
 }
diff --git a/drupal7/sites/all/modules/file_entity/views/views_handler_filter_schema_type.inc b/drupal7/sites/all/modules/file_entity/views/views_handler_filter_schema_type.inc
new file mode 100644
index 00000000..d3d8fbb8
--- /dev/null
+++ b/drupal7/sites/all/modules/file_entity/views/views_handler_filter_schema_type.inc
@@ -0,0 +1,41 @@
+<?php
+/**
+ * @file
+ * Filter by the file schema type.
+ */
+
+class views_handler_filter_schema_type extends views_handler_filter_in_operator {
+  function get_value_options() {
+    if (!isset($this->value_options)) {
+      $this->value_title = t('File Schema types');
+      $types = file_get_stream_wrappers(STREAM_WRAPPERS_VISIBLE);
+      $options = array();
+      foreach ($types as $type => $info) {
+        $options[$type] = t($info['name']);
+      }
+      asort($options);
+      $this->value_options = $options;
+    }
+  }
+
+  function op_simple() {
+    if (empty($this->value)) {
+      return;
+    }
+    $this->ensure_my_table();
+
+    // We use array_values() because the checkboxes keep keys and that can cause
+    // array addition problems.
+    $statements = array();
+
+    $not_in = $this->operator == 'not in' ? TRUE : FALSE;
+    $schema_operator = $not_in ? 'NOT LIKE' : 'LIKE';
+    $composite = $not_in ? ' AND ' : ' OR ';
+
+    foreach ($this->value as $schema) {
+      $statements[] = 'uri ' . $schema_operator . ' \'' . db_like($schema) . '://%\'';
+    }
+
+    $this->query->add_where_expression($this->options['group'], implode($composite, $statements));
+  }
+}
diff --git a/drupal7/sites/all/modules/media/includes/MediaBrowserUpload.inc b/drupal7/sites/all/modules/media/includes/MediaBrowserUpload.inc
index 65e99778..57721cb9 100644
--- a/drupal7/sites/all/modules/media/includes/MediaBrowserUpload.inc
+++ b/drupal7/sites/all/modules/media/includes/MediaBrowserUpload.inc
@@ -25,13 +25,7 @@ class MediaBrowserUpload extends MediaBrowserPlugin {
     module_load_include('inc', 'file_entity', 'file_entity.pages');
 
     $build = array();
-    if ($this->params['multiselect'] && module_exists('plupload')) {
-      $build['form'] = drupal_get_form('file_entity_add_upload_multiple', $this->params);
-      $build['#attached']['js'][] = drupal_get_path('module', 'media') . '/js/plugins/media.upload_multiple.js';
-    }
-    else {
-      $build['form'] = drupal_get_form('file_entity_add_upload', $this->params);
-    }
+    $build['form'] = drupal_get_form('file_entity_add_upload', $this->params);
 
     return $build;
   }
